#!BPY

"""
Name: 'ph_RestOnGround_V1'
Blender: 232
Group: 'Misc'
Tooltip: 'Drop on ground selected objects.'
"""
# Keeps objects above the floor!

import Blender
from Blender import Object, NMesh
from Blender.Draw import *
from Blender.BGL import *

BL_VERSION = Blender.Get('version')
if (BL_VERSION<=223):
	import Blender210

#######################
#### Fonction reduce ##
def reduce(list):     #
#######################

    liste2 = []
    for x in list:
        liste2.append(x)
    liste2.sort()
    list.reverse()
    for x in liste2:
        itemDouble = list.count(x)

        if itemDouble > 1:

            while itemDouble > 1:
                list.remove(x)
                itemDouble -= 1
    list.reverse()

    return list


###########################
def GlobalPosition(P, Obj):
###########################
	#
	# Prend les coordonnees locale d'un point (Vertice from Mesh)
	# Et les transforme en coordonnees global
	#
	if (BL_VERSION<=223):
		m = Obj.matrix
	else:
		m = Obj.getMatrix()

	try:    ############################## Version officielle ############################################

#		PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
#		PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
		PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
#		return [PX, PY, PZ]
		return PZ

	except: ############################## Version TUHOPUU ############################################

#		PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
#		PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
		PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
#		return [PX, PY, PZ]
		return PZ

###################
def RestOnGround():
###################

	Objs = Object.GetSelected()
	if Objs:

		check = 1
		listcheck = Objs
		listchild = []
		listparent = []
		listatraiter = []

		listPostparent = []

#		print "Objets selectionnes : ", Objs

		if len(listcheck) > 1:
			while listcheck:
				for o in listcheck:
					Prt = o.parent
					if Prt:
						listPostparent.append(o)
						if Prt in Objs:
							listchild.append(o)
							listparent.append(Prt)
						else:
							listatraiter.append(o)
					else:
						listatraiter.append(o)

				listcheck = listparent
				listparent = []
				if not listcheck:
					check = 0
#				print "listcheck = ", listcheck
#				print "check = ", check
#				print "listatraiter = ", listatraiter

			reduce(listatraiter) ########## On 'Remove' les doublons #####
#			print "listatraiter = ", listatraiter
#			print "listPostparent = ", listPostparent

			############ on ordonne les objets a taiter suivant qu'ils soient parent ou non #######
			listFirst = []
			listSeconde = []
			for o in listatraiter:
				if o in listPostparent:
					listSeconde.append(o)
				else:
					listFirst.append(o)

			listatraiter = listFirst
			listatraiter.extend(listSeconde)
#			print "Maintenant..."
#			print "listatraiter = ", listatraiter


		else:
			listatraiter = Objs

		for o in listatraiter:

			if o.getType() == 'Mesh':
				mesh = o.getData()
				obVerts = mesh.verts  #### Liste des vertex ####

				minZ = GlobalPosition(obVerts[0], o)
				MaxZ = minZ


				for v in obVerts:
					vz = GlobalPosition(v, o)

					if (vz < minZ):
						minZ = vz
					if (vz > MaxZ):
						MaxZ = vz

#				print "minZ =", minZ
#				print "MaxZ =", MaxZ

#				TailleZ = MaxZ - minZ
#				print "TailleZ =", TailleZ
#				print "Obj.LocZ = ",o.LocZ

				o.LocZ -= minZ


			else:
				o.LocZ = 0.0

	Blender.Redraw()


###########
def draw():
###########

	glClearColor(0.265, 0.41, 0.4, 1)
	glClear(GL_COLOR_BUFFER_BIT)

	glColor3f(0, 0, 0)
	glRasterPos2f(21, 59)
	Text("ph_RestOnGround_V1.py")
	glRasterPos2f(21, 58)
	Text("ph_RestOnGround_V1.py")
	glColor3f(1.0, 1.0, 1.0)
	glRasterPos2f(20, 60)
	Text("ph_RestOnGround_V1.py")

	Button("Exit", 1, 150, 20, 40, 25)
	Button("RestOnGround", 2, 20, 20, 95, 25, "Drop on ground selected objects.")



####################
def event(evt, val):
####################

	if (evt== QKEY and not val): Exit()


################
def bevent(evt):
################

	Blender.Window.Redraw()
	if   (evt== 1):
		Exit()

	elif (evt== 2):
		RestOnGround()



############
Register(draw, event, bevent)
